SystemOrganization addCategory: #ConfigurationOfExperimentalBit!

Object subclass: #ConfigurationOfExperimentalBit
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfExperimentalBit'!

!ConfigurationOfExperimentalBit class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 12/21/2011 14:41'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfExperimentalBit class methodsFor: 'private' stamp: 'MarianoMartinezPeck 12/21/2011 14:41'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfExperimentalBit class methodsFor: 'private' stamp: 'MarianoMartinezPeck 12/21/2011 14:41'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfExperimentalBit class methodsFor: 'private' stamp: 'MarianoMartinezPeck 12/21/2011 14:41'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfExperimentalBit class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 12/21/2011 14:41'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfExperimentalBit class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 12/21/2011 14:41'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfExperimentalBit class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 12/21/2011 14:41'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfExperimentalBit class methodsFor: 'loading' stamp: 'MarianoMartinezPeck 12/21/2011 14:41'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfExperimentalBit class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/21/2011 14:41'!
project

	^self new project! !

!ConfigurationOfExperimentalBit class methodsFor: 'development support' stamp: 'MarianoMartinezPeck 12/21/2011 14:41'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfExperimentalBit methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/21/2011 18:23'!
baseline10: spec 
        <version: '1.0-baseline'>
        
	spec for: #pharo do: [
		
		spec blessing: #baseline.
		spec repository: 'http://ss3.gemstone.com/ss/ExperimentalBit'.
	
		spec package: 'ExperimentalBit'.
		spec package: 'ExperimentalBitCogVMMaker'
			with: [ spec requires: #('CogVM') ].
		spec package: 'ExperimentalBitCogVMMakerOverrides'
			with: [ 
				spec requires: #('ExperimentalBitCogVMMaker').
				spec preLoadDoIt: #prepareCogForOverrides.
				spec postLoadDoIt: #postLoadCogForOverrides.
				 ].
			
		spec
			project: 'CogVM' with: [
			spec
				className: 'ConfigurationOfCog';
				loads: #('default' );
				file: 'ConfigurationOfCog';
				"Don't use #bleedingEdge because we need to be in zinc with platform code"
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
	
		spec
 			group: 'default' with: #('ExperimentalBit' );
			group: 'VMMakerGroup' with: #( 'ExperimentalBit' 'ExperimentalBitCogVMMaker' 'ExperimentalBitCogVMMakerOverrides' ).

	
	]! !

!ConfigurationOfExperimentalBit methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/21/2011 14:57'!
postLoadCogForOverrides
	(Smalltalk at: #ObjectMemory) initialize.! !

!ConfigurationOfExperimentalBit methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/21/2011 14:57'!
prepareCogForOverrides
	(Smalltalk at: #ObjectMemory) addClassVarNamed: 'AllButExperimentalBit'.
	(Smalltalk at: #ObjectMemory) addClassVarNamed: 'ExperimentalObjectBit'.
	
	! !

!ConfigurationOfExperimentalBit methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/21/2011 14:41'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfExperimentalBit methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/21/2011 15:03'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
        
	spec for: #pharo do: [
		
		spec blessing: #development.
		spec author: 'Mariano Martinez Peck'.
		spec description: '  Needed GIT  blessed repository, version: commit 4a65655f0e419248d09a2502ea13b6e787992691
 		'.
		
		spec project: 'CogVM' with: '3.6'.
	
	]! !
